<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWSBdeCustomPropertyDefinition ArrayType
 * @subpackage Arrays
 */
class ArrayOfWSBdeCustomPropertyDefinition extends AbstractStructArrayBase
{
    /**
     * The WSBdeCustomPropertyDefinition
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WSBdeCustomPropertyDefinition[]
     */
    public $WSBdeCustomPropertyDefinition;
    /**
     * Constructor method for ArrayOfWSBdeCustomPropertyDefinition
     * @uses ArrayOfWSBdeCustomPropertyDefinition::setWSBdeCustomPropertyDefinition()
     * @param \StructType\WSBdeCustomPropertyDefinition[] $wSBdeCustomPropertyDefinition
     */
    public function __construct(array $wSBdeCustomPropertyDefinition = array())
    {
        $this
            ->setWSBdeCustomPropertyDefinition($wSBdeCustomPropertyDefinition);
    }
    /**
     * Get WSBdeCustomPropertyDefinition value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WSBdeCustomPropertyDefinition[]|null
     */
    public function getWSBdeCustomPropertyDefinition()
    {
        return isset($this->WSBdeCustomPropertyDefinition) ? $this->WSBdeCustomPropertyDefinition : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWSBdeCustomPropertyDefinition method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWSBdeCustomPropertyDefinition method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWSBdeCustomPropertyDefinitionForArrayConstraintsFromSetWSBdeCustomPropertyDefinition(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWSBdeCustomPropertyDefinitionWSBdeCustomPropertyDefinitionItem) {
            // validation for constraint: itemType
            if (!$arrayOfWSBdeCustomPropertyDefinitionWSBdeCustomPropertyDefinitionItem instanceof \StructType\WSBdeCustomPropertyDefinition) {
                $invalidValues[] = is_object($arrayOfWSBdeCustomPropertyDefinitionWSBdeCustomPropertyDefinitionItem) ? get_class($arrayOfWSBdeCustomPropertyDefinitionWSBdeCustomPropertyDefinitionItem) : sprintf('%s(%s)', gettype($arrayOfWSBdeCustomPropertyDefinitionWSBdeCustomPropertyDefinitionItem), var_export($arrayOfWSBdeCustomPropertyDefinitionWSBdeCustomPropertyDefinitionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WSBdeCustomPropertyDefinition property can only contain items of type \StructType\WSBdeCustomPropertyDefinition, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WSBdeCustomPropertyDefinition value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WSBdeCustomPropertyDefinition[] $wSBdeCustomPropertyDefinition
     * @return \ArrayType\ArrayOfWSBdeCustomPropertyDefinition
     */
    public function setWSBdeCustomPropertyDefinition(array $wSBdeCustomPropertyDefinition = array())
    {
        // validation for constraint: array
        if ('' !== ($wSBdeCustomPropertyDefinitionArrayErrorMessage = self::validateWSBdeCustomPropertyDefinitionForArrayConstraintsFromSetWSBdeCustomPropertyDefinition($wSBdeCustomPropertyDefinition))) {
            throw new \InvalidArgumentException($wSBdeCustomPropertyDefinitionArrayErrorMessage, __LINE__);
        }
        if (is_null($wSBdeCustomPropertyDefinition) || (is_array($wSBdeCustomPropertyDefinition) && empty($wSBdeCustomPropertyDefinition))) {
            unset($this->WSBdeCustomPropertyDefinition);
        } else {
            $this->WSBdeCustomPropertyDefinition = $wSBdeCustomPropertyDefinition;
        }
        return $this;
    }
    /**
     * Add item to WSBdeCustomPropertyDefinition value
     * @throws \InvalidArgumentException
     * @param \StructType\WSBdeCustomPropertyDefinition $item
     * @return \ArrayType\ArrayOfWSBdeCustomPropertyDefinition
     */
    public function addToWSBdeCustomPropertyDefinition(\StructType\WSBdeCustomPropertyDefinition $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WSBdeCustomPropertyDefinition) {
            throw new \InvalidArgumentException(sprintf('The WSBdeCustomPropertyDefinition property can only contain items of type \StructType\WSBdeCustomPropertyDefinition, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WSBdeCustomPropertyDefinition[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WSBdeCustomPropertyDefinition|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WSBdeCustomPropertyDefinition|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WSBdeCustomPropertyDefinition|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WSBdeCustomPropertyDefinition|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WSBdeCustomPropertyDefinition|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WSBdeCustomPropertyDefinition
     */
    public function getAttributeName()
    {
        return 'WSBdeCustomPropertyDefinition';
    }
}
