<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWSEntryPermission ArrayType
 * @subpackage Arrays
 */
class ArrayOfWSEntryPermission extends AbstractStructArrayBase
{
    /**
     * The WSEntryPermission
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WSEntryPermission[]
     */
    public $WSEntryPermission;
    /**
     * Constructor method for ArrayOfWSEntryPermission
     * @uses ArrayOfWSEntryPermission::setWSEntryPermission()
     * @param \StructType\WSEntryPermission[] $wSEntryPermission
     */
    public function __construct(array $wSEntryPermission = array())
    {
        $this
            ->setWSEntryPermission($wSEntryPermission);
    }
    /**
     * Get WSEntryPermission value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WSEntryPermission[]|null
     */
    public function getWSEntryPermission()
    {
        return isset($this->WSEntryPermission) ? $this->WSEntryPermission : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWSEntryPermission method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWSEntryPermission method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWSEntryPermissionForArrayConstraintsFromSetWSEntryPermission(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWSEntryPermissionWSEntryPermissionItem) {
            // validation for constraint: itemType
            if (!$arrayOfWSEntryPermissionWSEntryPermissionItem instanceof \StructType\WSEntryPermission) {
                $invalidValues[] = is_object($arrayOfWSEntryPermissionWSEntryPermissionItem) ? get_class($arrayOfWSEntryPermissionWSEntryPermissionItem) : sprintf('%s(%s)', gettype($arrayOfWSEntryPermissionWSEntryPermissionItem), var_export($arrayOfWSEntryPermissionWSEntryPermissionItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WSEntryPermission property can only contain items of type \StructType\WSEntryPermission, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WSEntryPermission value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WSEntryPermission[] $wSEntryPermission
     * @return \ArrayType\ArrayOfWSEntryPermission
     */
    public function setWSEntryPermission(array $wSEntryPermission = array())
    {
        // validation for constraint: array
        if ('' !== ($wSEntryPermissionArrayErrorMessage = self::validateWSEntryPermissionForArrayConstraintsFromSetWSEntryPermission($wSEntryPermission))) {
            throw new \InvalidArgumentException($wSEntryPermissionArrayErrorMessage, __LINE__);
        }
        if (is_null($wSEntryPermission) || (is_array($wSEntryPermission) && empty($wSEntryPermission))) {
            unset($this->WSEntryPermission);
        } else {
            $this->WSEntryPermission = $wSEntryPermission;
        }
        return $this;
    }
    /**
     * Add item to WSEntryPermission value
     * @throws \InvalidArgumentException
     * @param \StructType\WSEntryPermission $item
     * @return \ArrayType\ArrayOfWSEntryPermission
     */
    public function addToWSEntryPermission(\StructType\WSEntryPermission $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WSEntryPermission) {
            throw new \InvalidArgumentException(sprintf('The WSEntryPermission property can only contain items of type \StructType\WSEntryPermission, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WSEntryPermission[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WSEntryPermission|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WSEntryPermission|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WSEntryPermission|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WSEntryPermission|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WSEntryPermission|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WSEntryPermission
     */
    public function getAttributeName()
    {
        return 'WSEntryPermission';
    }
}
